// Ejemplo FreeImage 6
// Modificar pixels
// Abril 2023, Salvador Pozo, Con Clase

#include <iostream>
#include <iomanip>
#include <Freeimage.h>
#include <cstring>
#include <cstdlib>

int main(int argc, char**argv)
{
    FIBITMAP* dib;
	char *lpszPathName;
    FREE_IMAGE_FORMAT fif = FIF_UNKNOWN;
    BYTE *bits;
    unsigned nPixels;
    RGBQUAD *pal;

	if(argc < 2) {
        printf("Usar: FreeImage006 <fichero>\n");
        return 0;
	}
	lpszPathName = argv[1];

	fif = FreeImage_GetFileType(lpszPathName, 0);
	if(fif == FIF_UNKNOWN) {
		fif = FreeImage_GetFIFFromFilename(lpszPathName);
	}
	if((fif != FIF_UNKNOWN) && FreeImage_FIFSupportsReading(fif)) {
		dib = FreeImage_Load(fif, lpszPathName, 0);
		std::cout << "Fichero: " << lpszPathName << std::endl;

		if(FreeImage_HasPixels(dib)) {
            std::cout << "Tiene pixels" << std::endl;
            pal = FreeImage_GetPalette(dib);
            if(!pal) {
                std::cout << "Mapa de bits sin paleta" << std::endl;
                std::cout << "Anchura: " << FreeImage_GetWidth(dib) << std::endl;
                std::cout << "Altura: " << FreeImage_GetHeight(dib) << std::endl;
                std::cout << "Sustituimos los pixels de color #27d82d por colores aleatorios: " << std::endl;
                RGBQUAD nuevo = {0xff, 0x33, 0x44, 0};
                RGBQUAD actual = {0x27, 0xd8, 0x2d, 0};
                RGBQUAD valor;
                for(unsigned int y = 0; y < FreeImage_GetHeight(dib); y++) {
                    for(unsigned int x = 0; x < FreeImage_GetWidth(dib); x++) {
                        FreeImage_GetPixelColor(dib, x, y, &valor);
                        nuevo.rgbRed = 256*(std::rand())/RAND_MAX;
                        nuevo.rgbGreen = 256*(std::rand())/RAND_MAX;
                        nuevo.rgbBlue = 256*(std::rand())/RAND_MAX;
                        if(valor.rgbRed == actual.rgbRed && valor.rgbGreen == actual.rgbGreen && valor.rgbBlue == actual.rgbBlue)
                            FreeImage_SetPixelColor(dib, x, y, &nuevo);
                    }
                }
                FreeImage_Save(FIF_PNG, dib, "modificado2.png", PNG_Z_BEST_COMPRESSION | PNG_INTERLACED);
            } else {
                std::cout << "Mapa de bits con paleta" << std::endl;
                bits = FreeImage_GetBits(dib);
                std::cout << "Anchura: " << FreeImage_GetWidth(dib) << std::endl;
                std::cout << "Altura: " << FreeImage_GetHeight(dib) << std::endl;
                std::cout << "Sustituimos los pixels de color #a7a7a7 por colores aleatorios: " << std::endl;
                BYTE b = 0x21;
                BYTE index;
                for(unsigned int y = 0; y < FreeImage_GetHeight(dib); y++) {
                    for(unsigned int x = 0; x < FreeImage_GetWidth(dib); x++) {
                        FreeImage_GetPixelIndex(dib, x, y, &index);
                        b = 256*(std::rand())/RAND_MAX;
                        if(index == 0xa7) FreeImage_SetPixelIndex(dib, x, y, &b);
                    }
                }
                FreeImage_Save(FIF_PNG, dib, "modificado3.png", PNG_Z_BEST_COMPRESSION | PNG_INTERLACED);
            }
		}
    }
	FreeImage_Unload(dib);

    return 0;
}
